unit ExportF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VASCIIExport, VHTMLExport, VRTFExport, VBaseExport, VExcelExport,
  VLaTeXExport, VSQLExport, StdCtrls,  Db, DBTables, ComCtrls, ExtCtrls, Mask,
  Buttons, Grids, ExtDlgs, Spin, VClipboardExport, VXMLExport, VDBFExport;

type
  TWorkState = (wsNone, wsRun);

type
  TfrmExport = class(TForm)
    Panel1: TPanel;
    sdExportFile: TSaveDialog;
    ColorDialog: TColorDialog;
    Pages: TPageControl;
    tsExportType: TTabSheet;
    rgExpType: TRadioGroup;
    tsFormats: TTabSheet;
    tsHTMLOptions: TTabSheet;
    btStart: TBitBtn;
    lbRecExpCaption: TLabel;
    lbRecExported: TLabel;
    edFileName: TEdit;
    btFile: TButton;
    sohoLabel1: TLabel;
    btCancel: TBitBtn;
    cbView: TCheckBox;
    sdTemplate: TSaveDialog;
    odTemplate: TOpenDialog;
    tsExcelOptions: TTabSheet;
    sohoLabel7: TLabel;
    sohoLabel8: TLabel;
    edExcelPageFooter: TEdit;
    edExcelPageHeader: TEdit;
    FontDialog: TFontDialog;
    PageControl1: TPageControl;
    tsHTMLPreview: TTabSheet;
    tsHTMLBasic: TTabSheet;
    HTMLPanel: TPanel;
    sohoLabel6: TLabel;
    BackPanel: TPanel;
    cbxTemplate: TComboBox;
    btSaveTemplate: TBitBtn;
    btLoadTemplate: TBitBtn;
    tsHTMLAdvanced: TTabSheet;
    sohoLabel12: TLabel;
    sohoLabel13: TLabel;
    mmHTMLHeader: TMemo;
    mmHTMLFooter: TMemo;
    rgHTMLCSS: TRadioGroup;
    sohoLabel14: TLabel;
    GroupBox1: TGroupBox;
    gbHTMLTableOptions: TGroupBox;
    seHTMLTableCellPadding: TSpinEdit;
    sohoLabel15: TLabel;
    sohoLabel16: TLabel;
    seHTMLTableCellSpacing: TSpinEdit;
    sohoLabel17: TLabel;
    sohoLabel18: TLabel;
    seHTMLTableBorder: TSpinEdit;
    sohoLabel19: TLabel;
    edHTMLTableAdvanced: TEdit;
    sohoLabel20: TLabel;
    edHTMLBodyAdvanced: TEdit;
    sohoLabel22: TLabel;
    sohoLabel11: TLabel;
    edHTMLTitle: TEdit;
    Panel2: TPanel;
    ColHead1: TPanel;
    Head1: TLabel;
    ColHead2: TPanel;
    Head2: TLabel;
    ColHead3: TPanel;
    Head3: TLabel;
    Row1: TPanel;
    Row2: TPanel;
    Row3: TPanel;
    OddRow3: TPanel;
    OddRow2: TPanel;
    OddRow1: TPanel;
    Row4: TPanel;
    Row5: TPanel;
    Row6: TPanel;
    OddRow6: TPanel;
    OddRow5: TPanel;
    OddRow4: TPanel;
    lbHTMLDefaultText: TLabel;
    lbHTMLLink: TLabel;
    lbHTMLVLink: TLabel;
    lbHTMLALink: TLabel;
    Data1: TLabel;
    Data2: TLabel;
    Data3: TLabel;
    Data4: TLabel;
    Data5: TLabel;
    Data6: TLabel;
    Data7: TLabel;
    Data8: TLabel;
    Data9: TLabel;
    Data10: TLabel;
    Data11: TLabel;
    Data12: TLabel;
    Table1: TTable;
    edHTMLCSS: TEdit;
    btHTMLCSS: TButton;
    edHTMLBackGround: TEdit;
    btHTMLBackGround: TButton;
    opdHTMLBackground: TOpenPictureDialog;
    odHTMLCSS: TOpenDialog;
    gbStdFormats: TGroupBox;
    sohoLabel2: TLabel;
    eCurFormat: TEdit;
    eDateTimeFormat: TEdit;
    sohoLabel3: TLabel;
    sohoLabel4: TLabel;
    eFloatFormat: TEdit;
    eIntFormat: TEdit;
    sohoLabel5: TLabel;
    gbUserFormats: TGroupBox;
    cbxFieldNames: TComboBox;
    cbxUserFormats: TComboBox;
    lbUserFormats: TListBox;
    btAddUserFormat: TButton;
    btEditUserFormat: TButton;
    btDeleteUserFormat: TButton;
    btClearUserFormats: TButton;
    GroupBox2: TGroupBox;
    cbHTMLMaxRecords: TCheckBox;
    Label1: TLabel;
    seHTMLMaxRecords: TSpinEdit;
    Label2: TLabel;
    HTMLDefaultFont: TComboBox;
    Label3: TLabel;
    tsSQLOptions: TTabSheet;
    Label6: TLabel;
    edSQLNullStr: TEdit;
    gbSQLCommit: TGroupBox;
    cbSQLUseCommit: TCheckBox;
    Label4: TLabel;
    seSQLCommitRecCount: TSpinEdit;
    Label5: TLabel;
    edSQLCommitStatement: TEdit;
    Label7: TLabel;
    mmSQLHeader: TMemo;
    mmSQLFooter: TMemo;
    Label8: TLabel;
    gbSQLCreateTable: TGroupBox;
    cbSQLCreateTable: TCheckBox;
    edSQLTableName: TEdit;
    Label9: TLabel;
    tsFields: TTabSheet;
    SrcList: TListBox;
    DstList: TListBox;
    Panel3: TPanel;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    Panel4: TPanel;
    btIncludeAll: TSpeedButton;
    btExclude: TSpeedButton;
    btExcludeAll: TSpeedButton;
    btInclude: TSpeedButton;
    cbUseCustomDrawing: TCheckBox;
    Label10: TLabel;
    eDateFormat: TEdit;
    Label11: TLabel;
    eTimeFormat: TEdit;
    ASCIIExp: TVASCIIExport;
    ExcelExp: TVExcelExport;
    HTMLExp: TVHTMLExport;
    RTFExp: TVRTFExport;
    LaTeXExp: TVLaTeXExport;
    SQLExp: TVSQLExport;
    XMLExp: TVXMLExport;
    ClipboardExp: TVClipboardExport;
    DBFExp: TVDBFExport;
    tsRTFOptions: TTabSheet;
    sohoLabel9: TLabel;
    pbxExcelDefaultFont: TPaintBox;
    btExcelDFontSelect: TButton;
    btExcelHFontSelect: TButton;
    pbxExcelHeaderFont: TPaintBox;
    sohoLabel10: TLabel;
    sohoLabel23: TLabel;
    pbxRTFDefaultFont: TPaintBox;
    btRTFDFontSelect: TBitBtn;
    btRTFHFontSelect: TBitBtn;
    pbxRTFHeaderFont: TPaintBox;
    sohoLabel24: TLabel;
    cbSQLCommitAfter: TCheckBox;
    cbPrint: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure rgExpTypeClick(Sender: TObject);
    procedure btFileClick(Sender: TObject);
    procedure cbxTemplateChange(Sender: TObject);
    procedure btStartExportClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure btCancelKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BackPanelClick(Sender: TObject);
    procedure Row1Click(Sender: TObject);
    procedure OddRow1Click(Sender: TObject);
    procedure ColHead1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Head3Click(Sender: TObject);
    procedure btSaveTemplateClick(Sender: TObject);
    procedure btLoadTemplateClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbHTMLDefaultTextClick(Sender: TObject);
    procedure Data1Click(Sender: TObject);
    procedure btHTMLBackGroundClick(Sender: TObject);
    procedure btHTMLCSSClick(Sender: TObject);
    procedure rgHTMLCSSClick(Sender: TObject);
    procedure ExpRecordExported(Sender: TObject; RecNo: Integer);
    procedure edFileNameChange(Sender: TObject);
    procedure btAddUserFormatClick(Sender: TObject);
    procedure btDeleteUserFormatClick(Sender: TObject);
    procedure btEditUserFormatClick(Sender: TObject);
    procedure lbUserFormatsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btClearUserFormatsClick(Sender: TObject);
    procedure ExpBeginExport(Sender: TObject);
    procedure cbxFieldNamesChange(Sender: TObject);
    procedure cbHTMLMaxRecordsClick(Sender: TObject);
    procedure cbSQLUseCommitClick(Sender: TObject);
    procedure cbSQLCreateTableClick(Sender: TObject);
    procedure btIncludeClick(Sender: TObject);
    procedure btIncludeAllClick(Sender: TObject);
    procedure btExcludeClick(Sender: TObject);
    procedure btExcludeAllClick(Sender: TObject);
    procedure PagesChange(Sender: TObject);
    procedure RTFExpGetRTFCellParams(Sender: TObject; Field: TField;
      var Align: TRTFAlign; AFont: TFont; var Background: TColor);
    procedure HTMLExpGetHTMLCellParams(Sender: TObject; Field: TField;
      var Align: TAlign; AFont: TFont; var Background: TColor);
    procedure pbxExcelDefaultFontPaint(Sender: TObject);
    procedure pbxExcelHeaderFontPaint(Sender: TObject);
    procedure btExcelDFontSelectClick(Sender: TObject);
    procedure btExcelHFontSelectClick(Sender: TObject);
    procedure pbxRTFDefaultFontPaint(Sender: TObject);
    procedure pbxRTFHeaderFontPaint(Sender: TObject);
    procedure btRTFDFontSelectClick(Sender: TObject);
    procedure btRTFHFontSelectClick(Sender: TObject);
    procedure cbSQLCommitAfterClick(Sender: TObject);
    procedure RTFExpEndExport(Sender: TObject);
  private
    { Private declarations }
    CurrentExport : TVExport;
    procedure PrepareExcelExport;
    procedure PrepareRTFExport;
    procedure PrepareHTMLExport;
    procedure PrepareASCIIExport(sType : TASCIIExportType);
    procedure PrepareLaTeXExport;
    procedure PrepareSQLExport;
    procedure RefreshHTMLPreview;
    procedure InitFormats;
    procedure SetCustomTemplate;
    procedure InitFieldsNames;
    procedure SetButtons;
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    procedure PaintSample(AFont: TFont; APaintBox: TPaintBox;
      PaintColor: Boolean);
    procedure CheckFont(AFont: TFont; APaintBox: TPaintBox);
  private
    FRecordsExported: integer;
    FWorkState: TWorkState;
    procedure SetRecordsExported(const Value: integer);
    procedure SetWorkState(const Value: TWorkState);
    property WorkState: TWorkState read FWorkState write SetWorkState;
    property RecordsExported : integer read FRecordsExported write SetRecordsExported;
  private
   aIntMask, aFltMask : string;
  public
    { Public declarations }
    DataSet : TDataSet;
  end;

var
  frmExport: TfrmExport;

implementation

uses ShellAPI;

{$R *.DFM}

type

  TFormatFieldType = (fftInteger, fftFloat, fftCurrency, fftDateTime);

function GetLeftPart(const str: string): string;
var
  EquPos: integer;
begin
  EquPos := Pos('=', str);
  if EquPos > 0 then Result := Trim(Copy(str, 1, EquPos - 1))
  else Result := '';
end;

procedure TfrmExport.InitFormats;
begin
  with CurrentExport.Formats do begin
    eIntFormat.Text := IntegerFormat;
    eFloatFormat.Text := FloatFormat;
    eDateFormat.Text := DateFormat;
    eTimeFormat.Text := TimeFormat;
    eDateTimeFormat.Text := DateTimeFormat;
    eCurFormat.Text := CurrencyFormat;
  end;
end;

procedure TfrmExport.RefreshHTMLPreview;
var
  i : integer;
begin
  edHTMLTitle.Text := HTMLExp.Title;
  with HTMLExp.HTMLOptions do begin
    BackPanel.Color := BackgroundColor;
    lbHTMLDefaultText.Font.Color := TextFont.Color;
    lbHTMLLink.Font.Color := LinkColor;
    lbHTMLVLink.Font.Color := VLinkColor;
    lbHTMLALink.Font.Color := ALinkColor;
  end;
  with HTMLExp.TableOptions do begin
    for i := 1 to 3 do begin
      (FindComponent('ColHead' + IntToStr(i)) as TPanel).Color := HeadersRowBgColor;
      (FindComponent('Head' + IntToStr(i)) as TLabel).Font.Color := HeadersRowFontColor;
    end;
    for i := 1 to 6 do begin
      (FindComponent('OddRow' + IntToStr(i)) as TPanel).Color := TableBgColor;
      (FindComponent('Row' + IntToStr(i)) as TPanel).Color := OddRowBgColor;
    end;
    for i := 1 to 12 do
      (FindComponent(Format('Data%d',[i])) as TLabel).Font.Color := TableFontColor;
  end;
end;

procedure TfrmExport.PrepareExcelExport;
begin
  ExcelExp.ExcelOptions.PageHeader := edExcelPageHeader.Text;
  ExcelExp.ExcelOptions.PageFooter := edExcelPageFooter.Text;
end;

procedure TfrmExport.PrepareRTFExport;
begin
  // comming soon
end;

procedure TfrmExport.PrepareLaTeXExport;
begin
  // comming soon
end;

procedure TfrmExport.PrepareSQLExport;
begin
  SQLExp.Header.Assign(mmSQLHeader.Lines);
  SQLExp.Footer.Assign(mmSQLFooter.Lines);
  SQLExp.CreateTableStatement := cbSQLCreateTable.Checked;
  SQLExp.TableName := edSQLTableName.Text;
  SQLExp.CommitRecCount := seSQLCommitRecCount.Value;
  SQLExp.CommitAfterScript := cbSQLCommitAfter.Checked;
  SQLExp.CommitStatement := edSQLCommitStatement.Text;
  SQLExp.NullString := edSQLNullStr.Text;
end;

procedure TfrmExport.PrepareHTMLExport;
begin
  with HTMLExp do begin
    Title := edHTMLTitle.Text;
    Header.Assign(mmHTMLHeader.Lines);
    Footer.Assign(mmHTMLFooter.Lines);
    if rgHTMLCSS.ItemIndex = 0 then UsingCSS := usInternal
    else begin
      UsingCSS := usExternal;
      CSSFileName := edHTMLCSS.Text;
    end;
    HTMLOptions.TextFont.Name := HTMLDefaultFont.Text;
    HTMLOptions.AdvancedAttributes.Add(edHTMLBodyAdvanced.Text);
    HTMLOptions.BackgroundFileName := edHTMLBackground.Text;
    TableOptions.CellPadding := seHTMLTableCellPadding.Value;
    TableOptions.CellSpacing := seHTMLTableCellSpacing.Value;
    TableOptions.Border := seHTMLTableBorder.Value;
    TableOptions.AdvancedAttributes.Add(edHTMLTableAdvanced.Text);
    if (cbHTMLMaxRecords.Enabled) and (seHTMLMaxRecords.Value > 0) then
      HTMLExp.MaxRecords := seHTMLMaxRecords.Value;
  end;
end;

procedure TfrmExport.PrepareASCIIExport(sType : TASCIIExportType);
begin
  ASCIIExp.ExportType := sType;
end;

procedure TfrmExport.FormShow(Sender: TObject);
begin
  RecordsExported := 0;
  cbxTemplate.ItemIndex := Integer(HTMLExp.HTMLTemplate);
  cbxTemplateChange(nil);
  CurrentExport := ExcelExp;
  sdExportFile.Filter := 'Microsoft Excel (*.xls)|*.xls';
  sdExportFile.DefaultExt := 'xls';
  // formats ...
  InitFormats();
  WorkState := wsNone;
  // HTML
  with HTMLExp.TableOptions do begin
    seHTMLTableCellPadding.Value := CellPadding;
    seHTMLTableCellSpacing.Value := CellSpacing;
    seHTMLTableBorder.Value := Border;
  end;
  mmHTMLHeader.Lines.Assign(HTMLExp.Header);
  mmHTMLFooter.Lines.Assign(HTMLExp.Footer);
  // SQL
  mmSQLHeader.Lines.Assign(SQLExp.Header);
  mmSQLFooter.Lines.Assign(SQLExp.Footer);
  edSQLNullStr.Text := SQLExp.NullString;
  cbSQLCreateTable.Checked := false;
  edSQLTableName.Enabled := false;
  seSQLCommitRecCount.Value := SQLExp.CommitRecCount;
  cbSQLUseCommit.Checked := false;
  seSQLCommitRecCount.Enabled := false;
  edSQLCommitStatement.Enabled := false;
  edSQLCommitStatement.Text := SQLExp.CommitStatement;

  ActiveControl := edFileName;
end;

procedure TfrmExport.rgExpTypeClick(Sender: TObject);
begin
  case rgExpType.ItemIndex of
    0: begin
      CurrentExport := ExcelExp;
      sdExportFile.Filter := 'Microsoft Excel files (*.xls)|*.xls';
      sdExportFile.DefaultExt := 'xls';
    end;
    1: begin
      CurrentExport := RTFExp;
      sdExportFile.Filter := 'Microsoft Word files (*.doc)|*.doc';
      sdExportFile.DefaultExt := 'doc';
    end;
    2: begin
      CurrentExport := RTFExp;
      sdExportFile.Filter := 'RTF files (*.rtf)|*.rtf';
      sdExportFile.DefaultExt := 'rtf';
    end;
    3: begin
      CurrentExport := HTMLExp;
      sdExportFile.Filter := 'HTML files (*.html, *.htm)|*.html;*.htm';
      sdExportFile.DefaultExt := 'html';
    end;
    4: begin
      CurrentExport := ASCIIExp;
      sdExportFile.Filter := 'Text files (*.txt)|*.txt';
      sdExportFile.DefaultExt := 'txt';
    end;
    5: begin
      CurrentExport := ASCIIExp;
      sdExportFile.Filter := 'CSV files (*.csv)|*.csv';
      sdExportFile.DefaultExt := 'csv';
    end;
    6: begin
      CurrentExport := ASCIIExp;
      sdExportFile.Filter := 'DIF files (*.dif)|*.dif';
      sdExportFile.DefaultExt := 'dif';
    end;
    7: begin
      CurrentExport := ASCIIExp;
      sdExportFile.Filter := 'SYLK files (*.slk)|*.slk';
      sdExportFile.DefaultExt := 'slk';
    end;
    8: begin
      CurrentExport := LaTeXExp;
      sdExportFile.Filter := 'LaTeX files (*.tex)|*.tex';
      sdExportFile.DefaultExt := 'tex';
    end;
    9: begin
      CurrentExport := SQLExp;
      sdExportFile.Filter := 'SQL files (*.sql)|*.sql';
      sdExportFile.DefaultExt := 'sql';
    end;
    10: begin
      CurrentExport := ClipboardExp;
    end;
    11: begin
      CurrentExport := XMLExp;
      sdExportFile.Filter := 'XML files (*.xml)|*.xml';
      sdExportFile.DefaultExt := 'xml';
    end;
    12: begin
      CurrentExport := DBFExp;
      sdExportFile.Filter := 'DBF files (*.dbf)|*.dbf';
      sdExportFile.DefaultExt := 'dbf';
    end
  end;
  tsHTMLOptions.TabVisible := (rgExpType.ItemIndex = 3);
  tsExcelOptions.TabVisible := (rgExpType.ItemIndex = 0);
  tsRTFOptions.TabVisible := (rgExpType.ItemIndex in [1,2]);
  tsSQLOptions.TabVisible := (rgExpType.ItemIndex = 9);
  tsFormats.TabVisible := not (rgExpType.ItemIndex in [9, 11]);
  cbUseCustomDrawing.Enabled := rgExpType.ItemIndex in [1..3];
  edFileName.Enabled := (rgExpType.ItemIndex <> 10);
  btFile.Enabled := (rgExpType.ItemIndex <> 10);
  cbView.Enabled := (rgExpType.ItemIndex = 10) or (edFileName.Text <> '');
  cbPrint.Enabled := (rgExpType.ItemIndex = 10) or (edFileName.Text <> '');
  if rgExpType.ItemIndex <> 10 then begin
    if edFileName.Text <> '' then
      edFileName.Text := ChangeFileExt(edFileName.Text, '.' +
        sdExportFile.DefaultExt);
  end;
  btStart.Enabled := (edFileName.Text <> '') or (rgExpType.ItemIndex = 10);
  InitFormats();
end;

procedure TfrmExport.btFileClick(Sender: TObject);
begin
  sdExportFile.FileName := '';
  if sdExportFile.Execute() then
    edFileName.Text := sdExportFile.FileName;
end;

procedure TfrmExport.cbxTemplateChange(Sender: TObject);
begin
  case cbxTemplate.ItemIndex of
    0: HTMLExp.HTMLTemplate := htCustom;
    else
      HTMLExp.HTMLTemplate := THTMLTemplate(cbxTemplate.ItemIndex);
  end;
  RefreshHTMLPreview();
end;

procedure TfrmExport.btStartExportClick(Sender: TObject);
begin
  if not  (CurrentExport is TVSQLExport) then begin
    CurrentExport.Formats.CurrencyFormat := eCurFormat.Text;
    CurrentExport.Formats.DateTimeFormat := eDateFormat.Text;
    CurrentExport.Formats.FloatFormat := eFloatFormat.Text;
    CurrentExport.Formats.IntegerFormat := eIntFormat.Text;
  end;
  CurrentExport.ShowFile := cbView.Checked;
  CurrentExport.PrintFile := cbPrint.Checked;

  WorkState := wsRun;
  try
    case rgExpType.ItemIndex of
      0:  PrepareExcelExport();
      1:  PrepareRtfExport();
      2:  PrepareRtfExport();
      3:  PrepareHTMLExport();
      4:  PrepareASCIIExport(etTxt);
      5:  PrepareASCIIExport(etCSV);
      6:  PrepareASCIIExport(etDIF);
      7:  PrepareASCIIExport(etSYLK);
      8:  PrepareLaTeXExport();
      9:  PrepareSQLExport();
    end;
    CurrentExport.DataSet := DataSet;
    if CurrentExport <> ClipboardExp then
      CurrentExport.FileName := edFileName.Text;
    CurrentExport.Execute();
    if not CurrentExport.ShowFile then
      ShowMessage(Format('%d records are exported!', [RecordsExported]));
  finally
    WorkState := wsNone;
  end;
end;

procedure TfrmExport.SetWorkState(const Value: TWorkState);
var
  bNone:Boolean;
begin
  if FWorkState <> Value then FWorkState := Value;
  case FWorkState of
    wsNone: begin
      Dataset.EnableControls();
      Caption := 'EMS QuickExport Demo Application';
      btCancel.Caption := 'Close';
    end;
    wsRun: begin
      DataSet.DisableControls();
      Caption := 'Exporting Data...';
      btCancel.Caption := 'Cancel';
    end;
  end;
  bNone := (FWorkState = wsNone);
  RecordsExported := 0;
  lbRecExported.Visible := not bNone;
  lbRecExpCaption.Visible := not bNone;
  btStart.Enabled := bNone and ((Trim(edFileName.Text) <> '') or
                                (rgExpType.ItemIndex = 10));
  rgExpType.Enabled := bNone;
  Pages.Enabled := bNone;
end;

procedure TfrmExport.SetRecordsExported(const Value: integer);
begin
  FRecordsExported := Value;
  if FRecordsExported > 0 then
    lbRecExported.Caption := Format('%d', [FRecordsExported]);
end;

procedure TfrmExport.btCancelClick(Sender: TObject);
begin
  case WorkState of
    wsNone: Close();
    wsRun:
      if MessageDlg('Abort export?', mtWarning, [mbYes,mbNo], 0) = mrYes then
        CurrentExport.Stop();
  end;
end;

procedure TfrmExport.btCancelKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then btCancel.Click();
end;

procedure TfrmExport.BackPanelClick(Sender: TObject);
var
  FColor:TColor;
begin
  ColorDialog.Color := BackPanel.Color;
  if ColorDialog.Execute() then begin
    FColor := ColorDialog.Color;
    HTMLExp.HTMLOptions.BackgroundColor := FColor;
    BackPanel.Color := FColor;
    SetCustomTemplate();
  end;
end;

procedure TfrmExport.Row1Click(Sender: TObject);
begin
  ColorDialog.Color := HTMLExp.TableOptions.TableBgColor;
  if ColorDialog.Execute() then begin
    HTMLExp.TableOptions.OddRowBgColor := ColorDialog.Color;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.OddRow1Click(Sender: TObject);
begin
  ColorDialog.Color := HTMLExp.TableOptions.OddRowBgColor;
  if ColorDialog.Execute() then begin
    HTMLExp.TableOptions.TableBgColor := ColorDialog.Color;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.ColHead1Click(Sender: TObject);
begin
  ColorDialog.Color := HTMLExp.TableOptions.HeadersRowBgColor;
  if ColorDialog.Execute() then begin
    HTMLExp.TableOptions.HeadersRowBgColor := ColorDialog.Color;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  Pages.ActivePage := tsExportType;
  aIntMask := ''; aFltMask := '';
  Table1.Active := true;
  DataSet := Table1;
  HTMLDefaultFont.Items.Assign(Screen.Fonts);
  rgExpTypeClick(nil);
  rgHTMLCSSClick(nil);
  edFileNameChange(nil);
  InitFieldsNames();
  cbxFieldNamesChange(nil);
   for I := 0 to ComponentCount - 1 do
    if (Components[I] is TVExport) then
      (Components[I] as TVExport).Formats.ResetFormats();
end;


procedure TfrmExport.Head3Click(Sender: TObject);
begin
  ColorDialog.Color := (Sender as TLabel).Font.Color;
  if ColorDialog.Execute() then begin
    HTMLExp.TableOptions.HeadersRowFontColor := ColorDialog.Color;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.Data1Click(Sender: TObject);
begin
  ColorDialog.Color := (Sender as TLabel).Font.Color;
  if ColorDialog.Execute() then begin
    HTMLExp.TableOptions.TableFontColor := ColorDialog.Color;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.SetCustomTemplate;
begin
  cbxTemplate.ItemIndex := 0;
end;

procedure TfrmExport.btSaveTemplateClick(Sender: TObject);
begin
  if sdTemplate.Execute() then
    HTMLExp.SaveTemplateToFile(sdTemplate.FileName);
end;

procedure TfrmExport.btLoadTemplateClick(Sender: TObject);
begin
  if odTemplate.Execute() then begin
    HTMLExp.LoadTemplateFromFile(odTemplate.FileName);
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.FormDestroy(Sender: TObject);
begin
  Table1.Active := false;
end;

procedure TfrmExport.lbHTMLDefaultTextClick(Sender: TObject);
begin
  ColorDialog.Color := (Sender as TLabel).Font.Color;
  if ColorDialog.Execute() then begin
    case (Sender as TComponent).Tag of
      1:  HTMLExp.HTMLOptions.TextFont.Color := ColorDialog.Color;
      11: HTMLExp.HTMLOptions.LinkColor := ColorDialog.Color;
      12: HTMLExp.HTMLOptions.VLinkColor := ColorDialog.Color;
      13: HTMLExp.HTMLOptions.ALinkColor := ColorDialog.Color;
    end;
    SetCustomTemplate();
    RefreshHTMLPreview();
  end;
end;

procedure TfrmExport.btHTMLBackGroundClick(Sender: TObject);
begin
  if opdHTMLBackground.Execute() then
    edHTMLBackGround.Text := opdHTMLBackground.FileName;
end;

procedure TfrmExport.btHTMLCSSClick(Sender: TObject);
begin
  if odHTMLCSS.Execute() then
    edHTMLCSS.Text := odHTMLCSS.FileName;
end;

procedure TfrmExport.rgHTMLCSSClick(Sender: TObject);
var
  bHTMLCSS: Boolean;
begin
  bHTMLCSS := (rgHTMLCSS.ItemIndex = 1);
  edHTMLCSS.Enabled := bHTMLCSS;
  btHTMLCSS.Enabled := bHTMLCSS;
end;

procedure TfrmExport.ExpRecordExported(Sender: TObject;
  RecNo: Integer);
begin
  RecordsExported := RecNo;
  Application.ProcessMessages();
end;

procedure TfrmExport.edFileNameChange(Sender: TObject);
var
  bFileNameAssigned: Boolean;
begin
  bFileNameAssigned := (Trim(edFileName.Text) <> '');
  btStart.Enabled := bFileNameAssigned;
  cbView.Enabled := bFileNameAssigned;
  cbPrint.Enabled := bFileNameAssigned;
end;

procedure TfrmExport.InitFieldsNames;
var
  i: integer;
begin
  with cbxFieldNames.Items do begin
    BeginUpdate();
    try
      Clear();
      for i := 0 to DataSet.FieldCount - 1 do begin
        SrcList.Items.Add(Dataset.Fields[i].FieldName);
        if Dataset.Fields[i].DataType in [ftInteger, ftWord, ftSmallint, ftAutoInc,
          ftFloat, ftCurrency, ftDate, ftTime, ftDateTime] then
          cbxFieldNames.Items.Add(Dataset.Fields[i].FieldName);
      end;
      if Count > 0 then
        cbxFieldNames.ItemIndex := 0
      else
        gbUserFormats.Enabled := false;
    finally
      EndUpdate();
    end;
  end;
end;

procedure TfrmExport.btAddUserFormatClick(Sender: TObject);
begin
  if cbxUserFormats.Text <> '' then
    lbUserFormats.Items.Add(cbxFieldNames.Text + '=' + cbxUserFormats.Text);
end;

procedure TfrmExport.btDeleteUserFormatClick(Sender: TObject);
begin
  if lbUserFormats.ItemIndex <> -1 then
    lbUserFormats.Items.Delete(lbUserFormats.ItemIndex);
end;


procedure TfrmExport.btEditUserFormatClick(Sender: TObject);
var
  OldFormatValue, NewFormatValue: string;
  FieldName: string;
begin
  if lbUserFormats.ItemIndex <> -1 then begin
    FieldName := GetLeftPart(lbUserFormats.Items[lbUserFormats.ItemIndex]);
    OldFormatValue := lbUserFormats.Items.Values[FieldName];
    NewFormatValue := InputBox('New format value', 'Enter Value:', OldFormatValue);
    if NewFormatValue <> OldFormatValue then
      lbUserFormats.Items.Values[FieldName] := NewFormatValue;
  end;
end;

procedure TfrmExport.lbUserFormatsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then begin
    btDeleteUserFormat.Click();
    Key := 0;
  end;
end;

procedure TfrmExport.btClearUserFormatsClick(Sender: TObject);
begin
  lbUserFormats.Clear();
end;

procedure TfrmExport.ExpBeginExport(Sender: TObject);
begin
  (Sender as TVExport).ExportedFields.Assign(DstList.Items);
  if not (Sender is TVSQLExport) then begin
    with (Sender as TVExport), (Sender as TVExport).Formats do begin
      IntegerFormat := eIntFormat.Text;
      FloatFormat := eFloatFormat.Text;
      DateFormat := eDateFormat.Text;
      TimeFormat := eTimeFormat.Text;
      DateTimeFormat := eDateTimeFormat.Text;
      CurrencyFormat := eCurFormat.Text;
      UserFormats.Assign(lbUserFormats.Items);
    end;
  end;
end;

procedure TfrmExport.cbxFieldNamesChange(Sender: TObject);
begin
  cbxUserFormats.Items.BeginUpdate();
  try
    cbxUserFormats.Clear();
    case Dataset.FieldByName(cbxFieldNames.Items[cbxFieldNames.ItemIndex]).DataType of
      ftDateTime: begin
        cbxUserFormats.Items.Add(ShortDateFormat);
        cbxUserFormats.Items.Add(LongDateFormat);
        cbxUserFormats.Items.Add(ShortTimeFormat);
        cbxUserFormats.Items.Add(LongTimeFormat);
        cbxUserFormats.Items.Add(ShortDateFormat + ' ' + ShortTimeFormat);
        cbxUserFormats.Items.Add(ShortDateFormat + ' ' + LongTimeFormat);
        cbxUserFormats.Items.Add(LongDateFormat + ' ' + ShortTimeFormat);
        cbxUserFormats.Items.Add(LongDateFormat + ' ' + LongTimeFormat);
      end;
      ftDate: begin
        cbxUserFormats.Items.Add(ShortDateFormat);
        cbxUserFormats.Items.Add(LongDateFormat);
      end;
      ftTime: begin
        cbxUserFormats.Items.Add(ShortTimeFormat);
        cbxUserFormats.Items.Add(LongTimeFormat);
      end;
      ftInteger, ftWord, ftSmallint, ftAutoInc: begin
        cbxUserFormats.Items.Add('#,###,##0');
        cbxUserFormats.Items.Add('0');
      end;
      ftFloat: begin
        cbxUserFormats.Items.Add('#,###,##0.00');
        cbxUserFormats.Items.Add('#,###,##0.000');
        cbxUserFormats.Items.Add('#,###,##0.0000');
        cbxUserFormats.Items.Add('0.00');
      end;
      ftCurrency: cbxUserFormats.Items.Add('00' + DecimalSeparator +
        '00' + CurrencyString);
    end;
    cbxUserFormats.ItemIndex := 0;
  finally
    cbxUserFormats.Items.EndUpdate();
  end;
end;

procedure TfrmExport.cbHTMLMaxRecordsClick(Sender: TObject);
begin
  seHTMLMaxRecords.Enabled := cbHTMLMaxRecords.Checked;
end;

procedure TfrmExport.cbSQLUseCommitClick(Sender: TObject);
begin
  seSQLCommitRecCount.Enabled := cbSQLUseCommit.Checked;
  edSQLCommitStatement.Enabled := cbSQLUseCommit.Checked or
                                  cbSQLCommitAfter.Checked;
end;

procedure TfrmExport.cbSQLCommitAfterClick(Sender: TObject);
begin
  edSQLCommitStatement.Enabled := cbSQLUseCommit.Checked or
    cbSQLCommitAfter.Checked;
end;


procedure TfrmExport.cbSQLCreateTableClick(Sender: TObject);
var
  bChecked: Boolean;
begin
  bChecked := cbSQLCreateTable.Checked;
  edSQLTableName.Enabled := bChecked;
  if bChecked and (SQLExp.Dataset is TTable) then
    edSQLTableName.Text := TTable(SQLExp.Dataset).TableName;
end;

{ Exported fields }

procedure TfrmExport.btIncludeClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TfrmExport.btIncludeAllClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TfrmExport.btExcludeClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TfrmExport.btExcludeAllClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.Add(DstList.Items[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TfrmExport.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  btInclude.Enabled := not SrcEmpty;
  btIncludeAll.Enabled := not SrcEmpty;
  btExclude.Enabled := not DstEmpty;
  btExcludeAll.Enabled := not DstEmpty;
end;

function TfrmExport.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TfrmExport.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then begin
      Items.Add(List.Items[I]);
      List.Items.Delete(I);
    end;
end;

procedure TfrmExport.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do begin
    SetFocus();
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons();
end;

procedure TfrmExport.PagesChange(Sender: TObject);
begin
  if Pages.ActivePage = tsFields then
    if SrcList.Items.Count > 0 then
      SetItem(SrcList, 0)
    else
      SetItem(DstList, 0);
end;

procedure TfrmExport.pbxExcelDefaultFontPaint(Sender: TObject);
begin
  PaintSample(ExcelExp.ExcelOptions.DefaultFont, pbxExcelDefaultFont, False);
end;

procedure TfrmExport.pbxExcelHeaderFontPaint(Sender: TObject);
begin
  PaintSample(ExcelExp.ExcelOptions.RowHeaderFont, pbxExcelHeaderFont,
    ColorToExcelColor(ExcelExp.ExcelOptions.RowHeaderFont.Color) <> eclDefault);
end;

procedure TfrmExport.btExcelDFontSelectClick(Sender: TObject);
begin
  CheckFont(ExcelExp.ExcelOptions.DefaultFont, pbxExcelDefaultFont);
end;

procedure TfrmExport.btExcelHFontSelectClick(Sender: TObject);
begin
  CheckFont(ExcelExp.ExcelOptions.RowHeaderFont, pbxExcelHeaderFont);
  ExcelExp.ExcelOptions.RowHeaderFontColor :=
    ColorToExcelColor(ExcelExp.ExcelOptions.RowHeaderFont.Color);
end;

procedure TfrmExport.PaintSample(AFont: TFont; APaintBox: TPaintBox;
  PaintColor: Boolean);
const
  SampleText = 'AaBbCc XxYyZz';
var
  TextLength: integer;
begin
  with APaintBox.Canvas do begin
    Pen.Color := clBlack;
    Brush.Color := clWhite;
    Brush.Style := bsSolid;
    Rectangle(0, 0, APaintBox.Width, APaintBox.Height);
    Font.Assign(AFont);
    if not PaintColor then
      Font.Color := clBlack;
    TextLength := TextWidth(SampleText);
    TextOut((APaintBox.Width - TextLength) div 2,
      (APaintBox.Height - TextHeight(SampleText)) div 2, SampleText);
  end;
end;

procedure TfrmExport.CheckFont(AFont: TFont; APaintBox: TPaintBox);
begin
  FontDialog.Font.Assign(AFont);
  if FontDialog.Execute() then begin
    AFont.Assign(FontDialog.Font);
    APaintBox.Repaint();
  end;
end;

procedure TfrmExport.pbxRTFDefaultFontPaint(Sender: TObject);
begin
  PaintSample(RTFExp.RTFOptions.DefaultFont, pbxRTFDefaultFont, False);
end;

procedure TfrmExport.pbxRTFHeaderFontPaint(Sender: TObject);
begin
  PaintSample(RTFExp.RTFOptions.HeaderFont, pbxRTFHeaderFont, False);
end;

procedure TfrmExport.btRTFDFontSelectClick(Sender: TObject);
begin
  CheckFont(RTFExp.RTFOptions.DefaultFont, pbxRTFDefaultFont);
end;

procedure TfrmExport.btRTFHFontSelectClick(Sender: TObject);
begin
  CheckFont(RTFExp.RTFOptions.HeaderFont, pbxRTFHeaderFont);
end;

procedure TfrmExport.RTFExpGetRTFCellParams(Sender: TObject; Field: TField;
  var Align: TRTFAlign; AFont: TFont; var Background: TColor);
begin
  if cbUseCustomDrawing.Enabled then begin
    if Field.FieldName = 'Population' then begin
      AFont.Name := 'Tahoma';
      AFont.Style := [fsBold];
      if Field.AsInteger > 10000000 then
         AFont.Color := clRed
      else
         AFont.Color := clBlue;
    end;
  end;
end;

procedure TfrmExport.HTMLExpGetHTMLCellParams(Sender: TObject;
  Field: TField; var Align: TAlign; AFont: TFont; var Background: TColor);
begin
  if cbUseCustomDrawing.Enabled then begin
    if Field.FieldName = 'Population' then begin
      if Field.AsInteger > 10000000 then begin
         Background := clRed;
         AFont.Style := [fsBold];
         AFont.Color := clYellow
      end
    end;
  end;
end;


procedure TfrmExport.RTFExpEndExport(Sender: TObject);
begin
  //with Sender as TVRTFExport do
  //  ShellExecute(Handle, 'print', PChar(FileName), '', '', SW_HIDE);
end;

end.
